#!/bin/bash  -x
#
# (C) 2005, Roberto A. Foglietta <roberto.foglietta@sad.it>
#

PRNT_DIR="/tmp/eltron"
MEM_FILE="$PRNT_DIR/memory.prev"
CSV_FILE="$PRNT_DIR/print.csv"
CMD_FILE="$PRNT_DIR/print.command"
LAY_FILE="$PRNT_DIR/print.layout"
RES_FILE="$PRNT_DIR/print.result"
PRT_FILE="$PRNT_DIR/print.start"
declare -i PRINT_STATUS=0
p310c="p310c_print -d /dev/lp0 -k /dev/ttyS0,57600 -S 1 -I 6 -E on"
if ! echo $PATH | grep -q "/usr/local/bin"; then
	export PATH=$PATH:/usr/local/bin
fi

function close_result_file() {
	egrep . $3 >$3.tmp
	#ATTENTION: last line feed is required
	echo -e "\tstatus $1: $2\n" >>$3.tmp
	mv -f $3.tmp $3
}

function eprint() {
	if [ "$1" == "" ]; then
		PRINT_STATUS=-2
		return -2
	fi

	if [ ! -f "$2" ]; then 
		echo "printing card ..."
		echo "$p310c $1 2>>$RES_FILE"
		eval "$p310c $1 2>>$RES_FILE"
		PRINT_STATUS=$?
	else
		declare -i n=$(cat $2 | wc -l)
		[ $n -lt 2 ] && sleep 1
		echo "printing $2 ..."
		#declare -i n=$(echo $2|rev|cut -d\. -f1)
		echo "$p310c $1 -c $2 2>>$RES_FILE"
		eval "$p310c $1 -c $2 2>>$RES_FILE"
		PRINT_STATUS=$?
	fi

#	egrep . $RES_FILE >$RES_FILE.tmp
#	echo -e "\tstatus print: $PRINT_STATUS\n" >>$RES_FILE.tmp
#	mv -f $RES_FILE.tmp $RES_FILE

	close_result_file print $PRINT_STATUS $RES_FILE
	return $PRINT_STATUS
}

pid="$(pidof $(basename $0))" 
pids=$(echo $pid | sed -e "s/$$//g")
for i in $pids; do kill $i; done
killall p310c_server 2>/dev/null

mkdir -p $PRNT_DIR
chmod -R a+xwr $PRNT_DIR
rm -f $MEM_FILE
cd $PRNT_DIR
while [ 1 ]; do
	sleep 1;
#=============================== SERVER =======================================#
	if ! pidof p310c_server | egrep . >/dev/null; then
#	if ! pidof p310c_server >/dev/null; then
		echo -n X
		su - nobody -c "p310c_server -l7" &
		continue
	fi
	echo -n .

#=============================== COMANDI ======================================#
	if [ -f $CMD_FILE ]; then
		rm -f $RES_FILE 
		command=$(cat $CMD_FILE)
		echo "executing $(cat $command) ..."
		eval "$p310c $command 2>$RES_FILE"
		PRINT_STATUS=$?

#		egrep . $RES_FILE >$RES_FILE.tmp
#		echo -e "\tstatus command: $PRINT_STATUS\n" >>$RES_FILE.tmp
#		mv -f $RES_FILE.tmp $RES_FILE

		close_result_file command $PRINT_STATUS $RES_FILE
		rm -f $CMD_FILE
	fi

#=============================== STAMPA =======================================#
	if [ -f $CSV_FILE -a -f $LAY_FILE -a -f $PRT_FILE ]; then
		modello=$(cat $LAY_FILE)
		options=$(cat $PRT_FILE)
		
	#=================== GESTIONE DELLE IMMAGINI ==========================#
		layout=$(dirname $modello)
		if [ -f $layout/colore.png ]; then
			options="$options -r $layout/colore.png"
			if [ -f $layout/resina.png ]; then
				options="$options -b $layout/resina.png"
			fi
		elif [ -f $layout/resina.png ]; then
			options="$options -m $layout/resina.png"
		fi
		
	#==================== GESTIONE DELLA STAMPATA =========================#
		rm -f $CMD_FILE $RES_FILE $PRT_FILE $(basename $modello).[0-9]*

		if [ ! -f "$modello" -o "$(egrep . $modello)" == "" ]; then
			touch $CSV_FILE
			eprint "$options"
		else
			if names=$(p310c_csvmod $CSV_FILE $modello 2>$RES_FILE); then
				for i in $names; do 
					eprint "$options" $i || break
				done
			else
				PRINT_STATUS=-1
				cat $CSV_FILE > $CSV_FILE.err 
				echo -e "\tprint failed due csv_model error" | tee -a $RES_FILE
			fi
		fi
		
	#================ VIA LIBERA ALLA LETTURA DELLO STATO =================#
		mv -f $CSV_FILE $CSV_FILE.prev
		rm -f $CSV_FILE 
	fi
done
