#!/bin/bash 
#
# (C) 2006, Roberto A. Foglietta <roberto@sad.it>
#           released under GPL v2 or later terms

tmpdir="/tmp/personale_treno"
datadir="/usr/local/share/eltron"
pp="p310c_print -d /dev/lp0 -k /dev/ttyS0,57600 -S1 -E on"

function testa() {
	clear 
	echo
	echo "==== SCRIPT PER LA STAMPA TESSERE TRENO ===="
	echo
	echo
}


testa 
echo "apri il contenitore tessere"
echo "premi invio..."
echo
read key
$pp --eject

testa 
declare -i frt=0 nky=-1
while [ $nky -ne 0 ]; do
  echo "inserisci le tessere da stampare sul retro"
  echo "premi N-invio dove N e' il numero di tessere da stampare"
  echo "premi 0-invio per proseguire"
  echo
  read key
  if [ "$key" == "" ]; then
    nky=-1
  else
    nky=$key
    echo "premuto \"$key\" ($nky)"
    if [ "$key" != "" -a $nky -gt 0 ]; then
      frt=1
      $pp -n $nky -m $datadir/personale_treno_retro/resina.png 
    fi
  fi
done

if [ $frt -gt 0 ]; then
  echo 
  echo "apri il contenitore tessere"
  echo "premi invio..."
  echo
  read key
  $pp --eject
fi

testa 
echo "sblocca e alza la testina di stampa metti"
echo "il nastro colori abbassa e blocca la testina"
echo "premi invio..."
echo
read key
$pp --loadribbon Color 

mkdir -p $tmpdir
cd $tmpdir
pwd
rm -f modello.mod.*
p310c_csvmod $datadir/personale_treno.csv $datadir/personale_treno_fronte/modello.mod

testa 
nky=-1
cat $datadir/personale_treno.csv | cut -d\# -f1 | egrep . | tr \, \ >/$tmpdir/banner 
echo >>$tmpdir/banner
echo "premi N-invio dove N e' il numero persona da stampare" >>$tmpdir/banner
echo "premi 0-invio per concludere" >>$tmpdir/banner
echo >>$tmpdir/banner
while [ $nky -ne 0 ]; do
  more $tmpdir/banner
  read key
  nky=$key
  echo "premuto "$key" ($nky)"
  if [ $key != "" -a $nky -gt 0 ]; then
    for i in 1 2 3; do
      [ -f modello.mod.$key ] && break
      [ $i -gt 2 ] && exit 1
      key=0"$key"
    done
    $pp -b $datadir/personale_treno_fronte/resina.png \
        -r $datadir/personale_treno_fronte/colore.png \
        -c modello.mod.$key
  fi
done

key=s
while [ "$key" != "n" -a "$key" != "N" ]; do
  testa 
  echo "desideri caricare il nastro nero? (S/N)"
  echo
  read key
  if [ "$key" == "s" -o "$key" == "S" ]; then
    $pp --loadribbon Monochrome 
    testa 
    echo "sblocca e alza la testina di stampa metti"
    echo "il nastro nero abbassa e blocca la testina"
    echo "premi invio..."
    echo
    read key
    $pp --loadribbon Monochrome 
    $pp --eject
    break
  elif [ "$key" == "n" -o "$key" == "N" ]; then
	break
  fi
done
