/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * COPYING NOTES
 *
 * client.c -- client main body
 * 
 * Copyright (C) 2002 Roberto A. Foglietta <robang@libero.it>
 * Copyright (C) 2002 GEA-Automotive <fogliettar@gea-automotive.com>
 * Copyright (C) 2005 Roberto A. Foglietta <me@roberto.foglietta.name>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * REVISION NOTES:
 * released 21-10-2002 by Roberto A. Foglietta
 * modified 12-04-2005 by Roberto A. Foglietta
 */

#include <stdio.h>
#include <stdlib.h>

#include "sclient.h"

static
int refresh(const char *strt)
{
	static int i = 0;
	printf("refresh func called n.%d\n", ++i);
	return i;
}

int main (int argc, char **argv)
{
	int port;
	char *phost = {"127.0.0.1"};
	
	if (argc == 3){
		port  = atoi (argv[2]);
		phost = argv[1]; 
	} else if (argc == 2)
		port = atoi (argv[1]);
	else
		port = _PORT;
	
	printf("\nAfter connection digit a command and press ENTER to send it:\n");
	my_socket_client (phost, port, refresh);
	
	return 0;
}
