/***************************************************************************
 *            main.c
 *
 *  Thu Apr  7 11:08:31 2005
 *  Copyright  2005  Roberto A. Foglietta
 *  roberto.foglietta@sad.it
 ****************************************************************************/

#define VERSION "2005-06-24 17:30"

#include <stdio.h>
#include <unistd.h>
//#include <string.h>
//#include <stdlib.h>

#include "rafdebug.h"
#include "replyfunc.h"
#include "mysignal.h"
#include "mainargs.h"
#include "server.h"

#ifdef USE_MYSQL
# include <mysql/mysql.h>
static MYSQL mysql;
#endif

int 
main (int argc, char **argv) {
	DEBUG(1);

	int ret = setup_args(argc, argv, VERSION);
	if(ret)
		return ret;
	
	if(hostname)
		PRINTF("HostName: %s\n", hostname);
#ifdef USE_MYSQL	
	if(dbport)
		PRINTF("dbPort  : %d\n", dbport);
	if(dbname) 
		PRINTF("DataBase: %s\n", dbname);
	if(username || password)
		PRINTF("UserName: %s (%s)\n", username, password);
	
	mysql_init(&mysql);
	if(!mysql_real_connect(&mysql, hostname, username, password, dbname, dbport, NULL, 0)) {
		PRINTF("Connection to %s failed by %s@%s:%d\n", dbname, username, hostname, dbport);
		fprintf(stderr, "connection error: %s\n", mysql_error(&mysql));
		return -3;
	}
	PRINTF("Connesso !\n");
#endif
	
	/********** LOOP PRINCIPALE **************************************************/
	
	signal (SIGINT, catch_int);
	PRINTF("Looping in listening command socket...\n");
	do { 
#ifdef USE_MYSQL
		if(!my_socket_server(NULL, skport, reply_func, NULL, &mysql))
#else	
		if(!my_socket_server(hostname, skport, reply_func, NULL, NULL))
#endif
			break;
		else
			usleep(POLLING_PAUSE);
	} while(!CTRL_C_FLAG);
	PRINTF("Looping in listening command socket: exited\n");
	
	return 0;
}
