/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * COPYING NOTES
 *
 * replyfunc.h -- replay function header
 * 
 * Copyright (C) 2002, Roberto A. Foglietta <robang@libero.it>
 * Copyright (C) 2002, GEA S.r.l. Generale Elettronica Automotive
 *
 * Copyright (C) 2004, Roberto A. Foglietta <me@roberto.foglietta.name>
 * Copyright (C) 2004, Tecno Elettrica Brianza snc di Riva P. & G.  
 *
 * Copyright (C) 2005, Roberto A. Foglietta <me@roberto.foglietta.name>
 * Copyright (C) 2005, SAD Trasporti Locali Bolzano s.p.a.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * REVISION NOTES:
 * released 21-10-2002 by Roberto A. Foglietta
 * modified 16-12-2004 by Roberto A. Foglietta
 * modified 12-04-2005 by Roberto A. Foglietta
 * modified 24-06-2005 by Roberto A. Foglietta
 */

#ifndef REPLAY_FUNC_H
#define REPLAY_FUNC_H

#define FALSE 0
#define TRUE  1

#define _ACOK "ALL_OK\n"
#define _FAIL "FAILED\n"
#define _STOP "CLOSED\n"

typedef char *(*REPLY_FNC)(const char *, void *mysql);
typedef int   (*ALARM_FNC)(void);

char *reply_func (const char *data, void *mysql);
enum _reply_func_type
{
	HELLO = 0,
#ifdef USE_MYSQL
	QUERY,
#endif
	HELP,
	BYE,
	N_ACT_FNC
};

char *act_hello(const char *data, void *mysql);
char *act_help (const char *data, void *mysql);
char *act_bye  (const char *data, void *mysql);

#ifdef USE_MYSQL
extern int dbQueryMode;
char *act_query(const char *data, void *mysql);
#endif

extern char *ACT_TEXT[N_ACT_FNC];
extern REPLY_FNC ACT_FUNC[N_ACT_FNC];

#endif /* REPLAY_FUNC_H */
