/***************************************************************************
 *            cnvcmp.c
 *  
 *  Tue Apr 26 12:04:29 2005
 *  (C) 2005  Roberto A. Foglietta <roberto.foglietta@sad.it>
 *  (C) 2005  Roberto A. Foglietta <me@roberto.foglietta.name>
 *  
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cnvcmp.h"

static
int repeat_find_first(char *d, int size) {
	int i;
/*
	for(i = 2; i < size; i++) {
		if(d[i-2] == d[i] && d[i-1] == d[i])
			return i-2;
	}
*/
	
	for(i = 1; i < size; i++) {
		if(d[i-1] == d[i])
			return i-1;
	}

	return size;
}

static
int repeat_count(char *d, int size) {
	/*
	int i = 1;  //0
	char c = d[i];
	while(c == d[i] && i < size)
		i++;
	*/
	
	int i;
	for(i = 1; *d == d[i] && i < size; i++)
		;
	return i;
}

#define min(a,b) (((a)<(b))?(a):(b))
#define round(a) (((int)(a)) + (( ((a)-((int)(a))) <0.5 )?0:1))
#include "rafdebug.h"

char *rlecompress(char *data, int *size, int type) {
	DEBUG(0);
	int n, s = *size, k = 0, i = 0;
	char *cmp = (char *)malloc((size_t)s*2);
	PRINTF("size = %d, cmp = 0x%04lx", s*2, (long)cmp);
	if(!cmp) {
		fprintf(stderr, "data compression failed\n");
		exit(-31);
	}

	n = repeat_count(&data[i], min(s-i,127));
	cmp[k++] = 128 + n;
	cmp[k++] = data[i];
	i += n;
	
	while(i < s) {
		/*n = repeat_find_first(&data[i], min(s-i,31));
		PRINTF("repeat_find_first(%d, %d) = %d\n", i, min(s-i,31), n);
		if(n > 0) {
			cmp[k++] = n;
			memcpy(&cmp[k], &data[i], n);
			k += n;
			i += n;
		} else {*/
		n = repeat_count(&data[i], min(s-i,127));
		PRINTF("repeat_count(%d, %d) = %d\n", i, min(s-i,127), n);
		if(n == 1) {
			if(type == FIVE_BIT_LEVEL) {
				cmp[k++] = data[i++];
			} else {
				n = repeat_find_first(&data[i], min(s-i,31));
				PRINTF("repeat_find_first(%d, %d) = %d\n", i, min(s-i,31), n);
				cmp[k++] = n;
				//for(n; n > 0; k++, i++)
				//	cmp[k] = data[i];
				memcpy(&cmp[k], &data[i], n);
				k += n;
				i += n;					
			}
		} else {
			cmp[k++] = 128 + n;
			cmp[k++] = data[i];
			i += n;
		}
		//}
	}

	/*
	n = repeat_count(&data[i], min(s-i,127));
	if(n == 0) {
		//PRINTF("FIRST BYTE ALWAYS NEED COPRESSION\n");
		cmp[k++] = 128 + 1;
		cmp[k++] = data[i++];
	}

	while(i < s) {
		n = repeat_find_first(&data[i], min(s-i,31));
		//fprintf(stderr,"repeat_find_first(%d, %d) = %d\n", i, min(s-i,31), n);
		if(n > 0) {
			cmp[k++] = n;
			memcpy(&cmp[k], &data[i], n);
			k += n;
			i += n;
		} 
	
		n = repeat_count(&data[i], min(s-i,127));
		//fprintf(stderr,"repeat_count(%d, %d) = %d\n", i, min(s-i,127), n);
		if(n > 0) {
			cmp[k++] = 128 + n;
			cmp[k++] = data[i];
			i += n;
		}
	}
	*/

	/* Il buffer ormai è stato impostato per ricevere il compresso
	if(*size < k) {
		memcpy(cmp, data, *size);
		k = *size;
	}*/
	
	if(*size >= 1024)
		fprintf(stderr,"RLE compressed %d bytes to %d bytes (ratio: %d%%)\n", *size, k, round( ((float)k*100)/(*size) ));

	*size = k;
	return cmp;
}


char *dataconvert(char *c, int *s) {
	DEBUG(0);
	char *dup = (char *)malloc(*s*2);
	int i, j;

	if(!dup) {
		fprintf(stderr,"memory allocation failed in data convertion\n");
		exit(-32);
	}
	
	for(j = 0, i = 0; i < *s; i++, j++) {
		if(c[i] == 0x1b || c[i] == 0x5b || c[i] == 0x0d) {
			dup[j] = 0x5b;
			PRINTF("%d] 0x%02x --> %c+0x%02x", i, c[i], dup[j], c[i]);
			j++;
		}
		dup[j] = c[i];
	}
	PRINTF("\n");
	
	if(j != i)
		fprintf(stderr,"Data lenght was %d bytes but after convertion is %d bytes\n", j, *s);	
	
	*s = j;
	return dup;
}
