/*
  This file is part of the Linux driver for the Eltron p310c plastic card printer
    Copyright (C) 2002 Flemming Frandsen <ff-p310c@partyticket.net>
    Based on initial work by Stian Skjelstad <stian@nixia.no>
    Materials (printer+cards+ribbons) provided by http://www.psi.no/
	
	Copyright (C) 2005 Roberto A. Foglietta <roberto.foglietta@sad.it>
    Copyright (C) 2005 Roberto A. Foglietta <me@roberto.foglietta.name>
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/
 
#ifndef _DEVICE_H
#define _DEVICE_H

#include <termio.h>
#include <unistd.h>
#include <errno.h>

extern int speeds[];
extern int spcods[];
extern int AbortOnAllErrors;

#define MIN_SPEED_IDX 		0
#define MAX_SPEED_IDX 		3
#define DEF_SPEED_IDX 		3
#define SET_SPEED 		"+B "

#define valid_speed_idx(ret)   (((ret) < MIN_SPEED_IDX || (ret) > MAX_SPEED_IDX)?DEF_SPEED_IDX:(ret))

#define TIMEOUT 300
#define TORESET	  0

#define VARNISH -2
#define RESIN   -1

/*
void set_parity(int fout, char *sb);
int set_baud(int fout, int idx);
int checkerr(char *cmd);
int tpause(int timeout);
*/

int speed_to_idx(char *str);
int setserial(int fd, char *ser, int sidx, char *prty);

int sendcmd(int fd, const char *cmd, ...);
//int sendicmd(int fd, char *c, int i);
int sendbmp(int fd, char *data, int *size, const char *cmd, int channel);
int sendzbmp(int fd, char *data, int *size, const char *cmd, int channel);
int sendczbmp(int fd, char *data, int *size, const char *cmd, int channel);
//int sendibinary(int fd, char *cmd, char *data, int *size, int i);
int sendtesto(int fd, char *txt);
int query_printer(int fd);

#endif /* _DEVICE_H */
